#include <stdio.h>

typedef enum { NoDir, Asc, Desc } sortdir;
typedef enum { NoKey, ColKey, FuncKey } keytype;


int openit( loc_t *loc, int flags, int bsize );
int writeit( loc_t *loc, char *buf, int nbytes );
int closeit( loc_t *loc );
void format_trigger( FILE *outfile, char *text, char *state );
void getSMICounts();
void getIndexSummary();
int getSystemPageSize();
long getDbspaceInfo();
int getTableCount( char *dbs, char *table );
void rexit(int stat);
char *strtoupper( char *out, char *in );
int findcounts( char *db, char *tb );
char *delimident( char *ident );
char *delimident2( char *ident, char *dident );
int obtainidxsize( char *db, char *tb, int tabno, int *len, double *rows );
void print_aggregates( FILE *outfile );
void print_alters( FILE *outfile, int pc );
void print_auths( int tabid,
                  char *tabname,
                  FILE *outfile,
		  char *owner,
                  int tabauths,
                  int colauths,
                  int grantas );
void print_casts( FILE *outfile );
short print_checks( FILE *outfile, int alone );
void check_form( FILE *outfile, char *checkstring );
int print_coltype( int is_rowtype,
		   FILE *outfile,
		   long tabid,
		   char *tabname,
		   char *owner,
		   syscolumns_t syscolumns,
		   int pc );
void print_constraints( FILE *outfile, int tflag );
void print_references( FILE *outfile, int tflag );
void print_defaults( FILE *outfile,
                     syscolumns_t syscolumns,
                     sysdefaults_t sysdefaults );
int print_distributions( FILE *outfile,
			 long tabid,
			 char *tabname,
			 char **columns );
char *NextKey( char *str, keytype *type, char **key );
void KeyCol( char *key, short *col, int *opcl, sortdir *ColDir );
int FuncId( char *key );
int FuncCol( sortdir *ColDir, char *FieldName );
void FuncOpCl( int *opcl );
void print_indexes( FILE *outfile, FILE *distfile, int SimpleFrags );
void print_lowstats( FILE *distfile, long tabid, char *tabname );
void print_procedures( FILE *outfile,
		       FILE *outfileG,
		       char *ptempl,
		       int grantas,
		       int funcs,
		       int doams );
int find_semi( char *string );
int find_proc( char *str, char **parenloc, char *pre_comment, char *emb_comment );
int print_puts( FILE *outfile, int CrColFlag );
void print_seconstraints( FILE *outfile, int tflag );
void print_sereferences( FILE *outfile, int tflag );
void print_seindexes( FILE *outfile, FILE *distfile );
void stripstr( char *str, int len );
void print_sequences( FILE *outfile, FILE *outfileG, char *DbOwner );
void print_synonyms( FILE *outfile, FILE *outfileG, int tabauths, int colauths, int grantas );
void print_triggers( FILE *outfile, char *tabtype, int tabid );
void print_types( FILE *outfile, FILE *grantfile );
void print_userauths( FILE *outfile, FILE *outfileG, int SuppressSetSessionAuth );
void print_langauths( FILE *outfile );
void print_views( int tabid,
                  char *tabname,
                  char *owner,
                  FILE *outfile,
                  FILE *outfileG,
                  int tabauths,
                  int colauths,
                  int grantas );
void print_viewref( int tabid,
		    FILE *outfile,
		    FILE *outfileG,
		    int tabauths,
		    int colauths,
		    int grantas );
void print_allviewrefs( FILE *outfile,
			FILE *outfileG,
			int tabauths,
			int colauths,
			int grantas );
void print_violations( FILE *outfile );
long return_extended(
		     long extended_id,
		     char owner[UNAMELEN],
		     char name[65536],
		     char mode[2] );
void usage( char *program );
char *cleancat( char *to, char *from, int flag );
void print_opclasses( FILE * );
void print_ams( FILE * );
void print_objectstate( FILE *outfile, char *state, char *state2 );
void print_directives( FILE *outfile, FILE *outfile2 );
int print_external(
    int tabid,
    FILE *outfile
);
void print_infrastructure( FILE *outfile, int which_way );
int find_break( char *word, char delim, int wrapcol );
int probe_external( int tabid, int colno, FILE *outfile );
void return_coltypes( int prcid, char *procstr );
void print_index_rename( FILE *outfile, char *i_tabname );
