 
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
 
#define DB_MAX 1024
#define DB_SIZE 150
 
int sqgetdbs( int *, char **, int, char *, int );
 
int main( int argc, char *argv[])
{
    $char remote_db[40];
    int ret_fcnt, n;
    char **dbnames;
    char *namearea;
    char Revision[] = "$Revision: 1.7 $";
 
    if (argc == 1)
        sqlstart();
    else if (argv[1][0] == '-') {
	if (argv[1][1] == 'V') {
	    fprintf( stderr,
		     "\n%s: %s Copyright 1998-2022 by Art S. Kagel.\n",
		     argv[0],
		     strtok(Revision, "$"));
	    fprintf( stderr,
		     "\tLicense for private usage (including use by "
		     "commercial enterprise\n"
		     "\tfor its own needs) is granted.  Commercial and "
		     "exploitation rights\n"
		     "\tare reserved.\n\n" );
	} else {
	    fprintf( stderr,
		     "Usage: %s [-V|-?|dbname@remotserver]\n",
		     argv[0] );
	}
	exit(0);
    }else {                                  /* assert one arg = dbname@ site */
        EXEC SQL whenever error stop;
        strcpy( remote_db, argv[1] );
        EXEC SQL database :remote_db;         /* access the remote site */
    }
 
    namearea = (char *)calloc( (int )DB_MAX, (int )DB_SIZE ); 
    dbnames  = (char **)calloc( (int )DB_MAX, sizeof (char *) ); 
 
    sqgetdbs( &ret_fcnt, dbnames, DB_MAX,  namearea, (DB_MAX * DB_SIZE) );
 
    printf("There are currently %d databases available:\n\n", ret_fcnt );
    printf("Number \tName \n");
    printf("====== \t==== \n");
    for ( n = 0; n < ret_fcnt; n++ ) 
        printf("%d - \t%s \n", n, *dbnames++ );
    return 0;
}
